<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>CoglBuffer: The Buffer Interface</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-buffer-apis.html" title="Allocating GPU Memory">
<link rel="prev" href="cogl-buffer-apis.html" title="Allocating GPU Memory">
<link rel="next" href="cogl-2.0-experimental-CoglAttributeBuffer---Buffers-of-vertex-attributes.html" title="CoglAttributeBuffer: Buffers of vertex attributes">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-buffer-apis.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-buffer-apis.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-2.0-experimental-CoglAttributeBuffer---Buffers-of-vertex-attributes.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.top_of_page"></a>CoglBuffer: The Buffer Interface</span></h2>
<p>CoglBuffer: The Buffer Interface — Common buffer functions, including data upload APIs</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsect1">
<a name="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.stability-level"></a><h2>Stability Level</h2>
Unstable, unless otherwise indicated
</div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer">CoglBuffer</a>;
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-is-buffer" title="cogl_is_buffer ()">cogl_is_buffer</a>                      (<em class="parameter"><code><span class="type">void</span> *object</code></em>);
unsigned <span class="returnvalue">int</span>        <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-get-size" title="cogl_buffer_get_size ()">cogl_buffer_get_size</a>                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>);
enum                <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferUpdateHint" title="enum CoglBufferUpdateHint">CoglBufferUpdateHint</a>;
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-set-update-hint" title="cogl_buffer_set_update_hint ()">cogl_buffer_set_update_hint</a>         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferUpdateHint" title="enum CoglBufferUpdateHint"><span class="type">CoglBufferUpdateHint</span></a> hint</code></em>);
<a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferUpdateHint" title="enum CoglBufferUpdateHint"><span class="returnvalue">CoglBufferUpdateHint</span></a> <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-get-update-hint" title="cogl_buffer_get_update_hint ()">cogl_buffer_get_update_hint</a>        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>);
enum                <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferAccess" title="enum CoglBufferAccess">CoglBufferAccess</a>;
enum                <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferMapHint" title="enum CoglBufferMapHint">CoglBufferMapHint</a>;
<span class="returnvalue">void</span> *              <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-map" title="cogl_buffer_map ()">cogl_buffer_map</a>                     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferAccess" title="enum CoglBufferAccess"><span class="type">CoglBufferAccess</span></a> access</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferMapHint" title="enum CoglBufferMapHint"><span class="type">CoglBufferMapHint</span></a> hints</code></em>);
<span class="returnvalue">void</span> *              <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-map-range" title="cogl_buffer_map_range ()">cogl_buffer_map_range</a>               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> offset</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> size</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferAccess" title="enum CoglBufferAccess"><span class="type">CoglBufferAccess</span></a> access</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferMapHint" title="enum CoglBufferMapHint"><span class="type">CoglBufferMapHint</span></a> hints</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-unmap" title="cogl_buffer_unmap ()">cogl_buffer_unmap</a>                   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-set-data" title="cogl_buffer_set_data ()">cogl_buffer_set_data</a>                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> offset</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *data</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> size</code></em>);

                    <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglPixelBuffer" title="CoglPixelBuffer">CoglPixelBuffer</a>;
<a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglPixelBuffer" title="CoglPixelBuffer"><span class="returnvalue">CoglPixelBuffer</span></a> *   <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-pixel-buffer-new" title="cogl_pixel_buffer_new ()">cogl_pixel_buffer_new</a>               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *context</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> size</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *data</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-is-pixel-buffer" title="cogl_is_pixel_buffer ()">cogl_is_pixel_buffer</a>                (<em class="parameter"><code><span class="type">void</span> *object</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.description"></a><h2>Description</h2>
<p>
The CoglBuffer API provides a common interface to manipulate
buffers that have been allocated either via <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-pixel-buffer-new" title="cogl_pixel_buffer_new ()"><code class="function">cogl_pixel_buffer_new()</code></a>
or <a class="link" href="cogl-2.0-experimental-CoglAttributeBuffer---Buffers-of-vertex-attributes.html#cogl-attribute-buffer-new" title="cogl_attribute_buffer_new ()"><code class="function">cogl_attribute_buffer_new()</code></a>. The API allows you to upload data
to these buffers and define usage hints that help Cogl manage your
buffer optimally.
</p>
<p>
Data can either be uploaded by supplying a pointer and size so Cogl
can copy your data, or you can <code class="function">mmap()</code> a CoglBuffer and then you can
copy data to the buffer directly.
</p>
<p>
One of the most common uses for CoglBuffers is to upload texture
data asynchronously since the ability to mmap the buffers into
the CPU makes it possible for another thread to handle the IO
of loading an image file and unpacking it into the mapped buffer
without blocking other Cogl operations.
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglBuffer"></a><h3>CoglBuffer</h3>
<pre class="programlisting">typedef struct _CoglBuffer CoglBuffer;</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-is-buffer"></a><h3>cogl_is_buffer ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_is_buffer                      (<em class="parameter"><code><span class="type">void</span> *object</code></em>);</pre>
<p>
Checks whether <em class="parameter"><code>buffer</code></em> is a buffer object.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>object</code></em> :</span></p></td>
<td>a buffer object</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the handle is a CoglBuffer, and <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> otherwise</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-buffer-get-size"></a><h3>cogl_buffer_get_size ()</h3>
<pre class="programlisting">unsigned <span class="returnvalue">int</span>        cogl_buffer_get_size                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>);</pre>
<p>
Retrieves the size of buffer
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>buffer</code></em> :</span></p></td>
<td>a buffer object</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>the size of the buffer in bytes</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglBufferUpdateHint"></a><h3>enum CoglBufferUpdateHint</h3>
<pre class="programlisting">typedef enum {
 /*&lt; prefix=COGL_BUFFER_UPDATE_HINT &gt;*/
  COGL_BUFFER_UPDATE_HINT_STATIC,
  COGL_BUFFER_UPDATE_HINT_DYNAMIC,
  COGL_BUFFER_UPDATE_HINT_STREAM
} CoglBufferUpdateHint;
</pre>
<p>
The update hint on a buffer allows the user to give some detail on how often
the buffer data is going to be updated.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><a name="COGL-BUFFER-UPDATE-HINT-STATIC:CAPS"></a><span class="term"><code class="literal">COGL_BUFFER_UPDATE_HINT_STATIC</code></span></p></td>
<td>the buffer will not change over time
</td>
</tr>
<tr>
<td><p><a name="COGL-BUFFER-UPDATE-HINT-DYNAMIC:CAPS"></a><span class="term"><code class="literal">COGL_BUFFER_UPDATE_HINT_DYNAMIC</code></span></p></td>
<td>the buffer will change from time to time
</td>
</tr>
<tr>
<td><p><a name="COGL-BUFFER-UPDATE-HINT-STREAM:CAPS"></a><span class="term"><code class="literal">COGL_BUFFER_UPDATE_HINT_STREAM</code></span></p></td>
<td>the buffer will be used once or a couple of
  times
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-buffer-set-update-hint"></a><h3>cogl_buffer_set_update_hint ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_buffer_set_update_hint         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferUpdateHint" title="enum CoglBufferUpdateHint"><span class="type">CoglBufferUpdateHint</span></a> hint</code></em>);</pre>
<p>
Sets the update hint on a buffer. See <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferUpdateHint" title="enum CoglBufferUpdateHint"><span class="type">CoglBufferUpdateHint</span></a> for a description
of the available hints.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>buffer</code></em> :</span></p></td>
<td>a buffer object</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>hint</code></em> :</span></p></td>
<td>the new hint</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-buffer-get-update-hint"></a><h3>cogl_buffer_get_update_hint ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferUpdateHint" title="enum CoglBufferUpdateHint"><span class="returnvalue">CoglBufferUpdateHint</span></a> cogl_buffer_get_update_hint        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>);</pre>
<p>
Retrieves the update hints set using <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-set-update-hint" title="cogl_buffer_set_update_hint ()"><code class="function">cogl_buffer_set_update_hint()</code></a>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>buffer</code></em> :</span></p></td>
<td>a buffer object</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>the <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferUpdateHint" title="enum CoglBufferUpdateHint"><span class="type">CoglBufferUpdateHint</span></a> currently used by the buffer</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglBufferAccess"></a><h3>enum CoglBufferAccess</h3>
<pre class="programlisting">typedef enum {
 /*&lt; prefix=COGL_BUFFER_ACCESS &gt;*/
 COGL_BUFFER_ACCESS_READ       = 1 &lt;&lt; 0,
 COGL_BUFFER_ACCESS_WRITE      = 1 &lt;&lt; 1,
 COGL_BUFFER_ACCESS_READ_WRITE = COGL_BUFFER_ACCESS_READ | COGL_BUFFER_ACCESS_WRITE
} CoglBufferAccess;
</pre>
<p>
The access hints for <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-set-update-hint" title="cogl_buffer_set_update_hint ()"><code class="function">cogl_buffer_set_update_hint()</code></a>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><a name="COGL-BUFFER-ACCESS-READ:CAPS"></a><span class="term"><code class="literal">COGL_BUFFER_ACCESS_READ</code></span></p></td>
<td>the buffer will be read
</td>
</tr>
<tr>
<td><p><a name="COGL-BUFFER-ACCESS-WRITE:CAPS"></a><span class="term"><code class="literal">COGL_BUFFER_ACCESS_WRITE</code></span></p></td>
<td>the buffer will written to
</td>
</tr>
<tr>
<td><p><a name="COGL-BUFFER-ACCESS-READ-WRITE:CAPS"></a><span class="term"><code class="literal">COGL_BUFFER_ACCESS_READ_WRITE</code></span></p></td>
<td>the buffer will be used for both reading and
  writing
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglBufferMapHint"></a><h3>enum CoglBufferMapHint</h3>
<pre class="programlisting">typedef enum {
 /*&lt; prefix=COGL_BUFFER_MAP_HINT &gt;*/
  COGL_BUFFER_MAP_HINT_DISCARD = 1 &lt;&lt; 0,
  COGL_BUFFER_MAP_HINT_DISCARD_RANGE = 1 &lt;&lt; 1
} CoglBufferMapHint;
</pre>
<p>
Hints to Cogl about how you are planning to modify the data once it
is mapped.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><a name="COGL-BUFFER-MAP-HINT-DISCARD:CAPS"></a><span class="term"><code class="literal">COGL_BUFFER_MAP_HINT_DISCARD</code></span></p></td>
<td>Tells Cogl that you plan to replace
   all the buffer's contents. When this flag is used to map a
   buffer, the entire contents of the buffer become undefined, even
   if only a subregion of the buffer is mapped.
</td>
</tr>
<tr>
<td><p><a name="COGL-BUFFER-MAP-HINT-DISCARD-RANGE:CAPS"></a><span class="term"><code class="literal">COGL_BUFFER_MAP_HINT_DISCARD_RANGE</code></span></p></td>
<td>Tells Cogl that you plan to
   replace all the contents of the mapped region. The contents of
   the region specified are undefined after this flag is used to
   map a buffer.
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.4</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-buffer-map"></a><h3>cogl_buffer_map ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span> *              cogl_buffer_map                     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferAccess" title="enum CoglBufferAccess"><span class="type">CoglBufferAccess</span></a> access</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferMapHint" title="enum CoglBufferMapHint"><span class="type">CoglBufferMapHint</span></a> hints</code></em>);</pre>
<p>
Maps the buffer into the application address space for direct
access. This is equivalent to calling <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-map-range" title="cogl_buffer_map_range ()"><code class="function">cogl_buffer_map_range()</code></a> with
zero as the offset and the size of the entire buffer as the size.
</p>
<p>
It is strongly recommended that you pass
<a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#COGL-BUFFER-MAP-HINT-DISCARD:CAPS"><code class="literal">COGL_BUFFER_MAP_HINT_DISCARD</code></a> as a hint if you are going to replace
all the buffer's data. This way if the buffer is currently being
used by the GPU then the driver won't have to stall the CPU and
wait for the hardware to finish because it can instead allocate a
new buffer to map.
</p>
<p>
The behaviour is undefined if you access the buffer in a way
conflicting with the <em class="parameter"><code>access</code></em> mask you pass. It is also an error to
release your last reference while the buffer is mapped.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>buffer</code></em> :</span></p></td>
<td>a buffer object</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>access</code></em> :</span></p></td>
<td>how the mapped buffer will be used by the application</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>hints</code></em> :</span></p></td>
<td>A mask of <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferMapHint" title="enum CoglBufferMapHint"><span class="type">CoglBufferMapHint</span></a>s that tell Cogl how
the data will be modified once mapped.</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A pointer to the mapped memory or
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> is the call fails. <span class="annotation">[<acronym title="Don't free data after the code is done."><span class="acronym">transfer none</span></acronym>]</span>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-buffer-map-range"></a><h3>cogl_buffer_map_range ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span> *              cogl_buffer_map_range               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> offset</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> size</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferAccess" title="enum CoglBufferAccess"><span class="type">CoglBufferAccess</span></a> access</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferMapHint" title="enum CoglBufferMapHint"><span class="type">CoglBufferMapHint</span></a> hints</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);</pre>
<p>
Maps a sub-region of the buffer into the application's address space
for direct access.
</p>
<p>
It is strongly recommended that you pass
<a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#COGL-BUFFER-MAP-HINT-DISCARD:CAPS"><code class="literal">COGL_BUFFER_MAP_HINT_DISCARD</code></a> as a hint if you are going to replace
all the buffer's data. This way if the buffer is currently being
used by the GPU then the driver won't have to stall the CPU and
wait for the hardware to finish because it can instead allocate a
new buffer to map. You can pass
<a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#COGL-BUFFER-MAP-HINT-DISCARD-RANGE:CAPS"><code class="literal">COGL_BUFFER_MAP_HINT_DISCARD_RANGE</code></a> instead if you want the
regions outside of the mapping to be retained.
</p>
<p>
The behaviour is undefined if you access the buffer in a way
conflicting with the <em class="parameter"><code>access</code></em> mask you pass. It is also an error to
release your last reference while the buffer is mapped.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>buffer</code></em> :</span></p></td>
<td>a buffer object</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>offset</code></em> :</span></p></td>
<td>Offset within the buffer to start the mapping</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>size</code></em> :</span></p></td>
<td>The size of data to map</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>access</code></em> :</span></p></td>
<td>how the mapped buffer will be used by the application</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>hints</code></em> :</span></p></td>
<td>A mask of <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBufferMapHint" title="enum CoglBufferMapHint"><span class="type">CoglBufferMapHint</span></a>s that tell Cogl how
the data will be modified once mapped.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>error</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> for catching exceptional errors</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A pointer to the mapped memory or
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> is the call fails. <span class="annotation">[<acronym title="Don't free data after the code is done."><span class="acronym">transfer none</span></acronym>]</span>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-buffer-unmap"></a><h3>cogl_buffer_unmap ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_buffer_unmap                   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>);</pre>
<p>
Unmaps a buffer previously mapped by <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-map" title="cogl_buffer_map ()"><code class="function">cogl_buffer_map()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>buffer</code></em> :</span></p></td>
<td>a buffer object</td>
</tr></tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-buffer-set-data"></a><h3>cogl_buffer_set_data ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_buffer_set_data                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglBuffer" title="CoglBuffer"><span class="type">CoglBuffer</span></a> *buffer</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> offset</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *data</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> size</code></em>);</pre>
<p>
Updates part of the buffer with new data from <em class="parameter"><code>data</code></em>. Where to put this new
data is controlled by <em class="parameter"><code>offset</code></em> and <em class="parameter"><code>offset</code></em> + <em class="parameter"><code>data</code></em> should be less than the
buffer size.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>buffer</code></em> :</span></p></td>
<td>a buffer object</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>offset</code></em> :</span></p></td>
<td>destination offset (in bytes) in the buffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>data</code></em> :</span></p></td>
<td>a pointer to the data to be copied into the buffer</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>size</code></em> :</span></p></td>
<td>number of bytes to copy</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> is the operation succeeded, <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> otherwise</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglPixelBuffer"></a><h3>CoglPixelBuffer</h3>
<pre class="programlisting">typedef struct _CoglPixelBuffer CoglPixelBuffer;</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-pixel-buffer-new"></a><h3>cogl_pixel_buffer_new ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglPixelBuffer" title="CoglPixelBuffer"><span class="returnvalue">CoglPixelBuffer</span></a> *   cogl_pixel_buffer_new               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *context</code></em>,
                                                         <em class="parameter"><code><span class="type">size_t</span> size</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *data</code></em>);</pre>
<p>
Declares a new <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglPixelBuffer" title="CoglPixelBuffer"><span class="type">CoglPixelBuffer</span></a> of <em class="parameter"><code>size</code></em> bytes to contain arrays of
pixels. Once declared, data can be set using <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-set-data" title="cogl_buffer_set_data ()"><code class="function">cogl_buffer_set_data()</code></a>
or by mapping it into the application's address space using
<a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#cogl-buffer-map" title="cogl_buffer_map ()"><code class="function">cogl_buffer_map()</code></a>.
</p>
<p>
If <em class="parameter"><code>data</code></em> isn't <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> then <em class="parameter"><code>size</code></em> bytes will be read from <em class="parameter"><code>data</code></em> and
immediately copied into the new buffer.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>context</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>size</code></em> :</span></p></td>
<td>The number of bytes to allocate for the pixel data.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>data</code></em> :</span></p></td>
<td>An optional pointer to vertex data to upload immediately</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>a newly allocated <a class="link" href="cogl-2.0-experimental-CoglBuffer---The-Buffer-Interface.html#CoglPixelBuffer" title="CoglPixelBuffer"><span class="type">CoglPixelBuffer</span></a>. <span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>]</span>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-is-pixel-buffer"></a><h3>cogl_is_pixel_buffer ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_is_pixel_buffer                (<em class="parameter"><code><span class="type">void</span> *object</code></em>);</pre>
<p>
Checks whether <em class="parameter"><code>object</code></em> is a pixel buffer.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>object</code></em> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglObject" title="CoglObject"><span class="type">CoglObject</span></a> to test</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the <em class="parameter"><code>object</code></em> is a pixel buffer, and <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>
otherwise</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.2</p>
<p class="stability">Stability Level: Unstable</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>